Subject: [nmrg] Example of intents (was: New Version Notification for draft-li-nmrg-intent-classification-00.txt)

From: "Ciavaglia, Laurent (Nokia - FR/Paris-Saclay)" <[email-masked]>
Date: Thu, 9 May 2019 08:53:30 +0000

Hello Brian, Will, all,

I also think that having examples of intents, and also good use cases is useful (but only to some extent, see later below).

FWIW, we've tried to have some examples back at IETF95 (cf attached presentation, slide #4), and also with draft-du-anima-an-intent.
You also have a use where intent could be applied with draft-ietf-anima-prefix-management.
Also one can found various examples of intents such as in NEMO, ODL, ONOS, etc. and I'm sure there are others.

However, I think the examples can vary a lot and depend on the "types" of intent they represent, e.g. service-, infrastructure-, operation-oriented intents, which also depend on "who" writes them (end-user/customer/tenant, operator...) I thus think that the role and where in the system the intent is expressed/taken into account can generate very different examples. And such examples are not necessarily exclusive. They don't necessarily always relate to each other neither.
I thus think it would be quite difficult to compare examples and to get something meaningful out of it. Nevertheless, I also think we should try this exercise and think more deeply if some higher level understanding can come from working with examples.
At the last NMRG virtual meeting (https://mailarchive.ietf.org/arch/msg/nmrg/L_FGkqXd-OiIDco0eJmlD8tnGsM), we discussed about the need to describe representative use cases / applications where intent based networking is useful, to gain and combine insights. 
Use cases should also drive experimental research to evaluate various techniques for the various components of an intent based system, and to allow determining their developability and executability on a large scale basis.
This will be on the agenda of the next virtual meetings and of the in-person interim mid-June (https://mailarchive.ietf.org/arch/msg/nmrg/CuORkRO-CNdv3mLhmLbT8Nj1d-s)
I think one interesting research challenge (and solutions to address it) resides in how to cope with various levels/types of intent expressions and still run a system consistently.

Best regards, Laurent.

> -----Original Message-----
> From: nmrg <[email-masked]> On Behalf Of Brian E Carpenter
> Sent: Wednesday, May 8, 2019 22:14
> To: Liushucheng (Will Liu) <[email-masked]>; [email-masked]
> Cc: [email-masked]
> Subject: Re: [nmrg] FW: New Version Notification for draft-li-nmrg-intent-
> classification-00.txt
> 
> On 08-May-19 21:46, Liushucheng (Will Liu) wrote:
> > Hi Brian,
> >
> > Thanks for your comments. I agree that the first sentence is not
> accurate and the rest of your comments.
> >
> > The main role of the first sentence is to lead to the second one. :)
> > We will modify it in next version to: Management personnel, such as
> network administrators, may have the knowledge of the underlying network.
> > Is that OK?
> 
> Yes, I think so. I hope we can soon have some concrete examples of intent,
> because for a long time the discussion has been very abstract.
> 
> Regards
>     Brian
> 
> >
> > Regards, / 致礼!
> > Will LIU  / 刘树成
> >
> > -----Original Message-----
> > From: Brian E Carpenter [mailto:[email-masked]]
> > Sent: Saturday, May 04, 2019 12:03 PM
> > To: Liushucheng (Will Liu) <[email-masked]>; [email-masked]
> > Cc: [email-masked]
> > Subject: Re: [nmrg] FW: New Version Notification for draft-li-nmrg-
> intent-classification-00.txt
> >
> > Hi,
> >
> > I appreciate this document as background for what is otherwise quite a
> confusing discussion.
> >
> > There is one statement that gives me a bit of difficulty, however:
> >
> >>    Management personnel, such as network Administrators, have complete
> >>    knowledge of the underlying network.  However, they may not
> >>    understand the details of the applications and services of Customers
> >>    and End-Users.
> >
> > The second sentence is certainly true. However, especially if autonomic
> networking is a success, I am not sure about the first sentence. As
> networks get more and more complex, and especially when virtual networks
> or slices are created dynamically and automatically, the administrators
> will *not* have complete knowledge of the underlying network. In fact, the
> intent itself may be the reason for this: the network is configured as a
> result of the intent, and the human administrators will then be unaware of
> the details. (They are presumably aware of the physical structure of the
> network, and the devices installed, but that is only part of the story.)
> >
> > Regards
> >    Brian Carpenter
> >
> > On 24-Apr-19 14:23, Liushucheng (Will Liu) wrote:
> >> Hi,
> >>
> >> I just did some small modifications and submit this draft as -nmrg,
> which replaced the old draft-li version.
> >>
> >> As we presented during last NMRG meeting, there are several shared
> principles between SDOs:
> >>   -intent should be declarative, using and depending on as few
> deployment details as possible and focusing on what and not how
> >>   -intent should provide an easy-to-use interface, and use terminology
> and concepts familiar to its target audience
> >>   -intent should be vendor-independent and portable across platforms
> >>   -the intent framework should be able to detect and resolve conflicts
> between multiple intents
> >>
> >> This document goal is to discuss and propose how to classify intents,
> so that  can be a good foundation for future discussion related to intent
> in IETF scope.
> >>
> >> In the draft we've listed Intent Classification based on :
> >> -Solutions, Users and their Purpose
> >> -When to Activate
> >> -Lifecycle Management Requirements
> >> -Granularity
> >>
> >> Slides we presented:
> >> https://datatracker.ietf.org/meeting/104/materials/slides-104-nmrg-
> sessb-intent-classification-00
> >>
> >> Your comments and contributions are welcome!
> >>
> >> Regards, / 致礼!
> >> Will LIU  / 刘树成
> >>
> >>
> >> -----Original Message-----
> >> From: [email-masked] [mailto:[email-masked]]
> >> Sent: Tuesday, April 23, 2019 8:41 PM
> >> To: Liushucheng (Will Liu) <[email-masked]>; John Strassner
> <[email-masked]>; Olga Havel <[email-masked]>;
> Xuweiping (David) <[email-masked]>; Ying Cheng
> <[email-masked]>; Liushucheng (Will Liu)
> <[email-masked]>; Chen Li <[email-masked]>
> >> Subject: New Version Notification for draft-li-nmrg-intent-
> classification-00.txt
> >>
> >>
> >> A new version of I-D, draft-li-nmrg-intent-classification-00.txt
> >> has been successfully submitted by Will (Shucheng) Liu and posted to
> the IETF repository.
> >>
> >> Name:		draft-li-nmrg-intent-classification
> >> Revision:	00
> >> Title:		Intent Classification
> >> Document date:	2019-04-22
> >> Group:		Individual Submission
> >> Pages:		13
> >> URL:            https://www.ietf.org/internet-drafts/draft-li-nmrg-
> intent-classification-00.txt
> >> Status:         https://datatracker.ietf.org/doc/draft-li-nmrg-intent-
> classification/
> >> Htmlized:       https://tools.ietf.org/html/draft-li-nmrg-intent-
> classification-00
> >> Htmlized:       https://datatracker.ietf.org/doc/html/draft-li-nmrg-
> intent-classification
> >>
> >>
> >> Abstract:
> >>    RFC 7575 defines Intent as an abstract high-level policy used to
> >>    operate the network. Intent management system includes an interface
> >>    for users to input requests and an engine to translate the intents
> >>    into the network configuration and manage their lifecycle. Up to
> >>    now, there is no commonly agreed definition, interface or model of
> >>    intent.
> >>
> >>    This document discusses what intent means to different stakeholders,
> >>    describes different ways to classify intent, and an associated
> >>    taxonomy of this classification. This is a foundation for discussion
> >>    intent related topics.
> >>
> >>
> >>
> >>
> >> Please note that it may take a couple of minutes from the time of
> submission until the htmlized version and diff are available at
> tools.ietf.org.
> >>
> >> The IETF Secretariat
> >>
> >> _______________________________________________
> >> nmrg mailing list
> >> [email-masked]
> >> https://www.irtf.org/mailman/listinfo/nmrg
> >>
> >
> 
> _______________________________________________
> nmrg mailing list
> [email-masked]
> https://www.irtf.org/mailman/listinfo/nmrg